// Copyright 2020-2021 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-twirp v7.1.1, DO NOT EDIT.
// source: buf/alpha/registry/v1alpha1/repository_tag.proto

package registryv1alpha1

import bytes "bytes"
import strings "strings"
import context "context"
import fmt "fmt"
import ioutil "io/ioutil"
import http "net/http"
import strconv "strconv"

import jsonpb "github.com/golang/protobuf/jsonpb"
import proto "github.com/golang/protobuf/proto"
import twirp "github.com/twitchtv/twirp"
import ctxsetters "github.com/twitchtv/twirp/ctxsetters"

// This is a compile-time assertion to ensure that this generated file
// is compatible with the twirp package used in your project.
// A compilation error at this line likely means your copy of the
// twirp package needs to be updated.
const _ = twirp.TwirpPackageIsVersion7

// ==============================
// RepositoryTagService Interface
// ==============================

// RepositoryTagService is the Repository tag service.
type RepositoryTagService interface {
	// CreateRepositoryTag creates a new repository tag.
	CreateRepositoryTag(context.Context, *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error)

	// ListRepositoryTags lists the repository tags associated with a Repository.
	ListRepositoryTags(context.Context, *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error)
}

// ====================================
// RepositoryTagService Protobuf Client
// ====================================

type repositoryTagServiceProtobufClient struct {
	client      HTTPClient
	urls        [2]string
	interceptor twirp.Interceptor
	opts        twirp.ClientOptions
}

// NewRepositoryTagServiceProtobufClient creates a Protobuf client that implements the RepositoryTagService interface.
// It communicates using Protobuf and can be configured with a custom HTTPClient.
func NewRepositoryTagServiceProtobufClient(baseURL string, client HTTPClient, opts ...twirp.ClientOption) RepositoryTagService {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	// Build method URLs: <baseURL>[<prefix>]/<package>.<Service>/<Method>
	serviceURL := sanitizeBaseURL(baseURL)
	serviceURL += baseServicePath(clientOpts.PathPrefix(), "buf.alpha.registry.v1alpha1", "RepositoryTagService")
	urls := [2]string{
		serviceURL + "CreateRepositoryTag",
		serviceURL + "ListRepositoryTags",
	}

	return &repositoryTagServiceProtobufClient{
		client:      client,
		urls:        urls,
		interceptor: twirp.ChainInterceptors(clientOpts.Interceptors...),
		opts:        clientOpts,
	}
}

func (c *repositoryTagServiceProtobufClient) CreateRepositoryTag(ctx context.Context, in *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "buf.alpha.registry.v1alpha1")
	ctx = ctxsetters.WithServiceName(ctx, "RepositoryTagService")
	ctx = ctxsetters.WithMethodName(ctx, "CreateRepositoryTag")
	caller := c.callCreateRepositoryTag
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateRepositoryTagRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateRepositoryTagRequest) when calling interceptor")
					}
					return c.callCreateRepositoryTag(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*CreateRepositoryTagResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*CreateRepositoryTagResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *repositoryTagServiceProtobufClient) callCreateRepositoryTag(ctx context.Context, in *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
	out := new(CreateRepositoryTagResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *repositoryTagServiceProtobufClient) ListRepositoryTags(ctx context.Context, in *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "buf.alpha.registry.v1alpha1")
	ctx = ctxsetters.WithServiceName(ctx, "RepositoryTagService")
	ctx = ctxsetters.WithMethodName(ctx, "ListRepositoryTags")
	caller := c.callListRepositoryTags
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListRepositoryTagsRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListRepositoryTagsRequest) when calling interceptor")
					}
					return c.callListRepositoryTags(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListRepositoryTagsResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListRepositoryTagsResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *repositoryTagServiceProtobufClient) callListRepositoryTags(ctx context.Context, in *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
	out := new(ListRepositoryTagsResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ================================
// RepositoryTagService JSON Client
// ================================

type repositoryTagServiceJSONClient struct {
	client      HTTPClient
	urls        [2]string
	interceptor twirp.Interceptor
	opts        twirp.ClientOptions
}

// NewRepositoryTagServiceJSONClient creates a JSON client that implements the RepositoryTagService interface.
// It communicates using JSON and can be configured with a custom HTTPClient.
func NewRepositoryTagServiceJSONClient(baseURL string, client HTTPClient, opts ...twirp.ClientOption) RepositoryTagService {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	// Build method URLs: <baseURL>[<prefix>]/<package>.<Service>/<Method>
	serviceURL := sanitizeBaseURL(baseURL)
	serviceURL += baseServicePath(clientOpts.PathPrefix(), "buf.alpha.registry.v1alpha1", "RepositoryTagService")
	urls := [2]string{
		serviceURL + "CreateRepositoryTag",
		serviceURL + "ListRepositoryTags",
	}

	return &repositoryTagServiceJSONClient{
		client:      client,
		urls:        urls,
		interceptor: twirp.ChainInterceptors(clientOpts.Interceptors...),
		opts:        clientOpts,
	}
}

func (c *repositoryTagServiceJSONClient) CreateRepositoryTag(ctx context.Context, in *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "buf.alpha.registry.v1alpha1")
	ctx = ctxsetters.WithServiceName(ctx, "RepositoryTagService")
	ctx = ctxsetters.WithMethodName(ctx, "CreateRepositoryTag")
	caller := c.callCreateRepositoryTag
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateRepositoryTagRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateRepositoryTagRequest) when calling interceptor")
					}
					return c.callCreateRepositoryTag(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*CreateRepositoryTagResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*CreateRepositoryTagResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *repositoryTagServiceJSONClient) callCreateRepositoryTag(ctx context.Context, in *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
	out := new(CreateRepositoryTagResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *repositoryTagServiceJSONClient) ListRepositoryTags(ctx context.Context, in *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "buf.alpha.registry.v1alpha1")
	ctx = ctxsetters.WithServiceName(ctx, "RepositoryTagService")
	ctx = ctxsetters.WithMethodName(ctx, "ListRepositoryTags")
	caller := c.callListRepositoryTags
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListRepositoryTagsRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListRepositoryTagsRequest) when calling interceptor")
					}
					return c.callListRepositoryTags(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListRepositoryTagsResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListRepositoryTagsResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *repositoryTagServiceJSONClient) callListRepositoryTags(ctx context.Context, in *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
	out := new(ListRepositoryTagsResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ===================================
// RepositoryTagService Server Handler
// ===================================

type repositoryTagServiceServer struct {
	RepositoryTagService
	interceptor      twirp.Interceptor
	hooks            *twirp.ServerHooks
	pathPrefix       string // prefix for routing
	jsonSkipDefaults bool   // do not include unpopulated fields (default values) in the response
}

// NewRepositoryTagServiceServer builds a TwirpServer that can be used as an http.Handler to handle
// HTTP requests that are routed to the right method in the provided svc implementation.
// The opts are twirp.ServerOption modifiers, for example twirp.WithServerHooks(hooks).
func NewRepositoryTagServiceServer(svc RepositoryTagService, opts ...interface{}) TwirpServer {
	serverOpts := twirp.ServerOptions{}
	for _, opt := range opts {
		switch o := opt.(type) {
		case twirp.ServerOption:
			o(&serverOpts)
		case *twirp.ServerHooks: // backwards compatibility, allow to specify hooks as an argument
			twirp.WithServerHooks(o)(&serverOpts)
		case nil: // backwards compatibility, allow nil value for the argument
			continue
		default:
			panic(fmt.Sprintf("Invalid option type %T on NewRepositoryTagServiceServer", o))
		}
	}

	return &repositoryTagServiceServer{
		RepositoryTagService: svc,
		pathPrefix:           serverOpts.PathPrefix(),
		interceptor:          twirp.ChainInterceptors(serverOpts.Interceptors...),
		hooks:                serverOpts.Hooks,
		jsonSkipDefaults:     serverOpts.JSONSkipDefaults,
	}
}

// writeError writes an HTTP response with a valid Twirp error format, and triggers hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func (s *repositoryTagServiceServer) writeError(ctx context.Context, resp http.ResponseWriter, err error) {
	writeError(ctx, resp, err, s.hooks)
}

// RepositoryTagServicePathPrefix is a convenience constant that could used to identify URL paths.
// Should be used with caution, it only matches routes generated by Twirp Go clients,
// that add a "/twirp" prefix by default, and use CamelCase service and method names.
// More info: https://twitchtv.github.io/twirp/docs/routing.html
const RepositoryTagServicePathPrefix = "/twirp/buf.alpha.registry.v1alpha1.RepositoryTagService/"

func (s *repositoryTagServiceServer) ServeHTTP(resp http.ResponseWriter, req *http.Request) {
	ctx := req.Context()
	ctx = ctxsetters.WithPackageName(ctx, "buf.alpha.registry.v1alpha1")
	ctx = ctxsetters.WithServiceName(ctx, "RepositoryTagService")
	ctx = ctxsetters.WithResponseWriter(ctx, resp)

	var err error
	ctx, err = callRequestReceived(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	if req.Method != "POST" {
		msg := fmt.Sprintf("unsupported method %q (only POST is allowed)", req.Method)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}

	// Verify path format: [<prefix>]/<package>.<Service>/<Method>
	prefix, pkgService, method := parseTwirpPath(req.URL.Path)
	if pkgService != "buf.alpha.registry.v1alpha1.RepositoryTagService" {
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}
	if prefix != s.pathPrefix {
		msg := fmt.Sprintf("invalid path prefix %q, expected %q, on path %q", prefix, s.pathPrefix, req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}

	switch method {
	case "CreateRepositoryTag":
		s.serveCreateRepositoryTag(ctx, resp, req)
		return
	case "ListRepositoryTags":
		s.serveListRepositoryTags(ctx, resp, req)
		return
	default:
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}
}

func (s *repositoryTagServiceServer) serveCreateRepositoryTag(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveCreateRepositoryTagJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveCreateRepositoryTagProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *repositoryTagServiceServer) serveCreateRepositoryTagJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateRepositoryTag")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(CreateRepositoryTagRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	handler := s.RepositoryTagService.CreateRepositoryTag
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateRepositoryTagRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateRepositoryTagRequest) when calling interceptor")
					}
					return s.RepositoryTagService.CreateRepositoryTag(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*CreateRepositoryTagResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*CreateRepositoryTagResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *CreateRepositoryTagResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateRepositoryTagResponse and nil error while calling CreateRepositoryTag. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true, EmitDefaults: !s.jsonSkipDefaults}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *repositoryTagServiceServer) serveCreateRepositoryTagProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateRepositoryTag")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(CreateRepositoryTagRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.RepositoryTagService.CreateRepositoryTag
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *CreateRepositoryTagRequest) (*CreateRepositoryTagResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateRepositoryTagRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateRepositoryTagRequest) when calling interceptor")
					}
					return s.RepositoryTagService.CreateRepositoryTag(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*CreateRepositoryTagResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*CreateRepositoryTagResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *CreateRepositoryTagResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *CreateRepositoryTagResponse and nil error while calling CreateRepositoryTag. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *repositoryTagServiceServer) serveListRepositoryTags(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveListRepositoryTagsJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveListRepositoryTagsProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *repositoryTagServiceServer) serveListRepositoryTagsJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListRepositoryTags")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	reqContent := new(ListRepositoryTagsRequest)
	unmarshaler := jsonpb.Unmarshaler{AllowUnknownFields: true}
	if err = unmarshaler.Unmarshal(req.Body, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the json request could not be decoded"))
		return
	}

	handler := s.RepositoryTagService.ListRepositoryTags
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListRepositoryTagsRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListRepositoryTagsRequest) when calling interceptor")
					}
					return s.RepositoryTagService.ListRepositoryTags(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListRepositoryTagsResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListRepositoryTagsResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *ListRepositoryTagsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListRepositoryTagsResponse and nil error while calling ListRepositoryTags. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	var buf bytes.Buffer
	marshaler := &jsonpb.Marshaler{OrigName: true, EmitDefaults: !s.jsonSkipDefaults}
	if err = marshaler.Marshal(&buf, respContent); err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	respBytes := buf.Bytes()
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *repositoryTagServiceServer) serveListRepositoryTagsProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListRepositoryTags")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := ioutil.ReadAll(req.Body)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to read request body"))
		return
	}
	reqContent := new(ListRepositoryTagsRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.RepositoryTagService.ListRepositoryTags
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *ListRepositoryTagsRequest) (*ListRepositoryTagsResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListRepositoryTagsRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListRepositoryTagsRequest) when calling interceptor")
					}
					return s.RepositoryTagService.ListRepositoryTags(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListRepositoryTagsResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListRepositoryTagsResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *ListRepositoryTagsResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListRepositoryTagsResponse and nil error while calling ListRepositoryTags. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *repositoryTagServiceServer) ServiceDescriptor() ([]byte, int) {
	return twirpFileDescriptor6, 0
}

func (s *repositoryTagServiceServer) ProtocGenTwirpVersion() string {
	return "v7.1.1"
}

// PathPrefix returns the base service path, in the form: "/<prefix>/<package>.<Service>/"
// that is everything in a Twirp route except for the <Method>. This can be used for routing,
// for example to identify the requests that are targeted to this service in a mux.
func (s *repositoryTagServiceServer) PathPrefix() string {
	return baseServicePath(s.pathPrefix, "buf.alpha.registry.v1alpha1", "RepositoryTagService")
}

var twirpFileDescriptor6 = []byte{
	// 518 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x54, 0x51, 0x6b, 0xdb, 0x3c,
	0x14, 0x45, 0x6e, 0xbe, 0x6f, 0xed, 0xcd, 0x92, 0x82, 0xb6, 0x87, 0xcc, 0x61, 0x24, 0x78, 0x30,
	0xca, 0x1e, 0xec, 0x35, 0x83, 0x75, 0xd0, 0xb7, 0xee, 0x69, 0x30, 0x46, 0xe7, 0xe4, 0xa9, 0x2f,
	0x41, 0x4e, 0x6e, 0x54, 0xb1, 0xd8, 0xf2, 0x24, 0x39, 0xac, 0xfd, 0x05, 0x83, 0xc1, 0xa0, 0x2f,
	0x1b, 0xfb, 0x21, 0xfb, 0x7f, 0xc3, 0x52, 0x9d, 0xc4, 0x34, 0x09, 0xe4, 0xcd, 0x3a, 0xba, 0xe7,
	0xdc, 0xa3, 0x73, 0x65, 0xc1, 0xeb, 0xa4, 0x98, 0x45, 0x6c, 0x9e, 0x5f, 0xb3, 0x48, 0x21, 0x17,
	0xda, 0xa8, 0x9b, 0x68, 0x71, 0x6a, 0x81, 0xd3, 0x48, 0x61, 0x2e, 0xb5, 0x30, 0x52, 0xdd, 0x8c,
	0x0d, 0xe3, 0x61, 0xae, 0xa4, 0x91, 0xb4, 0x9b, 0x14, 0xb3, 0xd0, 0x16, 0x84, 0x15, 0x23, 0xac,
	0x18, 0x7e, 0x7f, 0x25, 0xc7, 0x72, 0xb1, 0x52, 0x62, 0xb9, 0x70, 0x74, 0xbf, 0xc7, 0xa5, 0xe4,
	0x73, 0x8c, 0xec, 0xaa, 0xac, 0x36, 0x22, 0x45, 0x6d, 0x58, 0x9a, 0xbb, 0x82, 0xe0, 0x8e, 0x40,
	0x2b, 0x5e, 0x36, 0x1e, 0x31, 0x4e, 0xdb, 0xe0, 0x89, 0x69, 0x87, 0xf4, 0xc9, 0xc9, 0x51, 0xec,
	0x89, 0x29, 0x3d, 0x87, 0xe6, 0x44, 0x21, 0x33, 0x38, 0x2e, 0xb9, 0x1d, 0xaf, 0x4f, 0x4e, 0x9a,
	0x03, 0x3f, 0x74, 0xc2, 0x61, 0x25, 0x1c, 0x8e, 0x2a, 0xe1, 0x18, 0x5c, 0x79, 0x09, 0x50, 0x0a,
	0x8d, 0x8c, 0xa5, 0xd8, 0x69, 0x58, 0x39, 0xfb, 0x4d, 0x7b, 0xd0, 0x9c, 0xc8, 0x34, 0x15, 0x66,
	0x6c, 0xb7, 0xfe, 0xb3, 0x5b, 0xe0, 0xa0, 0x4f, 0x2c, 0xc5, 0x60, 0x01, 0xfe, 0x7b, 0x2b, 0x51,
	0x33, 0x16, 0xe3, 0xd7, 0x02, 0xb5, 0xa1, 0x2f, 0xa0, 0xb5, 0x96, 0xd4, 0xd2, 0xea, 0xe3, 0x15,
	0xf8, 0x61, 0xba, 0xec, 0xeb, 0x6d, 0xef, 0x7b, 0xf0, 0xa0, 0x6f, 0x0e, 0xdd, 0x8d, 0x7d, 0x75,
	0x2e, 0x33, 0x8d, 0xf4, 0x33, 0xb4, 0xeb, 0x23, 0xb2, 0x9d, 0x9b, 0x83, 0x57, 0xe1, 0x8e, 0x19,
	0x85, 0x75, 0xad, 0x35, 0xeb, 0x23, 0xc6, 0x83, 0x5f, 0x04, 0x9e, 0x7d, 0x14, 0xda, 0xd4, 0x8a,
	0xf4, 0x5e, 0x27, 0xed, 0xc2, 0x51, 0xce, 0x38, 0x8e, 0xb5, 0xb8, 0x75, 0xc7, 0x6d, 0xc5, 0x87,
	0x25, 0x30, 0x14, 0xb7, 0x48, 0x9f, 0x03, 0xd8, 0x4d, 0x23, 0xbf, 0x60, 0x76, 0x7f, 0x62, 0x5b,
	0x3e, 0x2a, 0x01, 0xda, 0x81, 0x47, 0x0a, 0x17, 0xa8, 0xb4, 0x1b, 0xd0, 0x61, 0x5c, 0x2d, 0x83,
	0x3f, 0x04, 0xfc, 0x4d, 0xc6, 0xee, 0xa3, 0x18, 0xc2, 0x71, 0x3d, 0x0a, 0xdd, 0x21, 0xfd, 0x83,
	0x3d, 0xb3, 0x68, 0xd7, 0xb2, 0xd0, 0xf4, 0x25, 0x1c, 0x67, 0xf8, 0xcd, 0x8c, 0xd7, 0x1c, 0xbb,
	0xf1, 0xb5, 0x4a, 0xf8, 0xb2, 0x72, 0x3d, 0xf8, 0xeb, 0xc1, 0xd3, 0x9a, 0xd2, 0x10, 0xd5, 0x42,
	0x4c, 0x90, 0xfe, 0x24, 0xf0, 0x64, 0xc3, 0x00, 0xe9, 0xd9, 0x4e, 0x53, 0xdb, 0xaf, 0x9a, 0xff,
	0x6e, 0x7f, 0xa2, 0x0b, 0x28, 0x68, 0x7c, 0xff, 0x1d, 0x78, 0xf4, 0x07, 0x01, 0xfa, 0x30, 0x45,
	0xfa, 0x76, 0xa7, 0xec, 0xd6, 0xfb, 0xe0, 0x9f, 0xed, 0xcd, 0x5b, 0x73, 0x43, 0x2e, 0xee, 0x08,
	0xf4, 0x26, 0x32, 0xdd, 0x25, 0x72, 0x41, 0x6b, 0x0a, 0x97, 0xe5, 0xcf, 0x7d, 0x75, 0xc5, 0x85,
	0xb9, 0x2e, 0x92, 0x70, 0x22, 0xd3, 0x28, 0x29, 0x66, 0x49, 0x21, 0xe6, 0xd3, 0xf2, 0x23, 0x12,
	0x99, 0x41, 0x95, 0xb1, 0x79, 0xc4, 0x31, 0x73, 0x2f, 0x4c, 0xc4, 0x65, 0xb4, 0xe3, 0x89, 0x3b,
	0xaf, 0x90, 0x0a, 0x48, 0xfe, 0xb7, 0xb4, 0x37, 0xff, 0x02, 0x00, 0x00, 0xff, 0xff, 0x71, 0x11,
	0xa5, 0x2f, 0x19, 0x05, 0x00, 0x00,
}
